Subject: [apps-discuss] I-D Action: draft-ietf-appsawg-rfc3536bis-00.txt

From: [email-masked]
Date: Fri, 06 May 2011 15:01:30 -0700

A New Internet-Draft is available from the on-line Internet-Drafts directories. This draft is a work item of the Applications Area Working Group Working Group of the IETF.

	Title           : Terminology Used in Internationalization in the IETF
	Author(s)       : Paul Hoffman
                          John C Klensin
	Filename        : draft-ietf-appsawg-rfc3536bis-00.txt
	Pages           : 46
	Date            : 2011-05-03

   This document provides a glossary of terms used in the IETF when
   discussing internationalization.  The purpose is to help frame
   discussions of internationalization in the various areas of the IETF
   and to help introduce the main concepts to IETF participants.

A URL for this Internet-Draft is:
http://www.ietf.org/internet-drafts/draft-ietf-appsawg-rfc3536bis-00.txt

Internet-Drafts are also available by anonymous FTP at:
ftp://ftp.ietf.org/internet-drafts/

This Internet-Draft can be retrieved at:
ftp://ftp.ietf.org/internet-drafts/draft-ietf-appsawg-rfc3536bis-00.txt

---

From: Mykyta Yevstifeyev <[email-masked]>
Date: Mon, 09 May 2011 08:06:16 +0300

Hello all,

We've recently adopted draft-hoffman-rfc3536bis as WG document.  I'd 
like to provide some comments on it.

 From Section 1.1, last paragraph:

>     This document uses definitions from many documents that have been
>     developed outside the IETF.  The primary documents used are:
>
>    [ ... ]
>
>     o  IETF RFCs, including the Character Set Policy specification
>        [RFC2277  <http://tools.ietf.org/html/rfc2277>]
This sounds a bit confusing, since the previous sentence says "outside 
the IETF" and the next one mentions IETF RFCs.  So I propose to change 
it as follows:

>      This document uses definitions from many documents, including those
>      developed outside the IETF.  Mostly, the following documents
>      were used:
>
>      [ as current draft ]

 From Section 2, "language" definition:

>     language
>
>        A language is a way that humans interact.  The use of language
>        occurs in many forms, the most common of which are speech,
>        writing, and signing.<NONE>
I think this definition is not correct.  "A way that humans interact" is 
too generalized.  I suppose the following definition would suit better here.

>     language
>
>        A language is a set of conventions on rules affecting humans'
>        speech.  The most common use of a language is speaking and
>        writing. <NONE>
>
>        [ as in current draft ]

Also "character" definition.  It would be useful to mention that 
"character" is often abbreviated to "char"

 From Section 4.1:
>     punctuation
>
>        Characters that separate units of text,  [ . . . ] they are also used in
>        mathematical and scientific formulae, for example.<UNICODE>
>
>     symbol
>
>        One of a set of characters  [ . . . ]
>
>        Examples of symbols include characters for mathematical operators,
>         [ . . . ]

I see these two definitions give a bit contiguous specification of where 
chars used in formula.  You should either clarify the use of punctuation 
marks in formula or consider such chars belonging to one of such category.

Also from Section 4.1:

>     control character
I think we can clarify a bit this definition by mentioning: "The 
semantics of control characters depend on the application they are used 
with.  The most common control characters semantics are specified in 
ISO/IEC 6429:1992 [ISO6429]" and adding the appropriate reference to ISO 
6429, like this: "ISO/IEC, "ISO/IEC 6429:1992. Information technology -- 
Control functions for coded character sets",1992."

Proposal for inclusion of definition in Section 8.  I think we could 
also define "noncharacter" here (and appropriate entry in the Index).  
My proposed definition:

>      noncharacter
>
>         A noncharacter is a code point that is permanently reserved
>         in some particular coded character set and is generally
>         forbidden to be used in open data interchange. <UNICODE>

Some comments on References:

>     [UNICODE]  The Unicode Consortium, "The Unicode Standard, Version
>                5.2.0", Mountain View, CA: The Unicode Consortium,
This version - 5.2.0 - is obsolete.  It is superseded by 6.0.0; the 
reference should be: "The Unicode Consortium. The Unicode Standard, 
Version 6.0.0, (Mountain View, CA: The Unicode Consortium, 2011. ISBN 
978-1-936213-01-6) <http://www.unicode.org/versions/Unicode6.0.0/>"

>     [ISO3166]  ISO, "ISO 3166-1:2006 - Codes for the representation of
>                names of countries and their subdivisions -- Part 1:
>                Country codes", 20066.
I don't think they've invented time machine to write this in 20066 :-)  
Obviously, this is a typo: s/20066/2006

I also think the reference to [CHARMOD] is a bit incorrect as well.  I 
propose:

> Duerst, M., Ed., Yergeau, F., Ed., Ishida, R., Ed., Wolf, M., Ed. and 
> T. Texin, Ed., "Character Model for the World Wide Web 1.0", W3C 
> Recommendation, February 2005. <http://www.w3.org/TR/charmod/>
To finish, why the intended status for this draft is BCP?  Longstanding 
IETF practice is to publish glossaries as Informational docs 
(previously, FYIs); examples are http://tools.ietf.org/html/rfc1208, 
http://tools.ietf.org/html/rfc1983, http://tools.ietf.org/html/rfc4949 
and the predecessor of this draft itself - 
http://tools.ietf.org/html/rfc3536.  I think Informational would suit 
better here.

All the best,
Mykyta Yevstifeyev

---

From: Paul Hoffman <[email-masked]>
Date: Mon, 9 May 2011 08:23:18 -0700

On May 8, 2011, at 10:06 PM, Mykyta Yevstifeyev wrote:

> This sounds a bit confusing, since the previous sentence says "outside the IETF" and the next one mentions IETF RFCs.

Fixed.

>>       writing, and signing. <NONE>
>> 
> I think this definition is not correct.  "A way that humans interact" is too generalized.  I suppose the following definition would suit better here.
> 
>>     language
>>   

Your definition is too limiting. Clearly, we are not only talking about speech.

> Also "character" definition.  It would be useful to mention that "character" is often abbreviated to "char"

Noted.

>>       mathematical and scientific formulae, for example. <UNICODE>
>> 
>>    symbol
>> 
> I see these two definitions give a bit contiguous specification of where chars used in formula.  You should either clarify the use of punctuation marks in formula or consider such chars belonging to one of such category.

A particular character can be considered both punctuation and a symbol.

> Also from Section 4.1:
> 
>>    control character
>> 
> I think we can clarify a bit this definition by mentioning: "The semantics of control characters depend on the application they are used with.  The most common control characters semantics are specified in ISO/IEC 6429:1992 [ISO6429]" and adding the appropriate reference to ISO 6429, like this: "ISO/IEC, "ISO/IEC 6429:1992. Information technology -- Control functions for coded character sets",1992."

This seems like overkill. We don't define the semantics of any other code points; why do it for control characters?

> Proposal for inclusion of definition in Section 8.  I think we could also define "noncharacter" here (and appropriate entry in the Index).  My proposed definition:
> 
>>      noncharacter
>>        

"noncharacter" is not a term commonly used in internationalization, I believe.

>>    [UNICODE
>> ]  The Unicode Consortium, "The Unicode Standard, Version
> This version - 5.2.0 - is obsolete.  It is superseded by 6.0.0; the reference should be: "The Unicode Consortium. The Unicode Standard, Version 6.0.0, (Mountain View, CA: The Unicode Consortium, 2011. ISBN 978-1-936213-01-6) <http://www.unicode.org/versions/Unicode6.0.0/>"

Noted.

> 
>>    [ISO3166
>> ]  ISO, "ISO 3166-1:2006 - Codes for the representation of
> I don't think they've invented time machine to write this in 20066 :-)  Obviously, this is a typo: s/20066/2006

Good catch.

> I also think the reference to [CHARMOD] is a bit incorrect as well.  I propose:
> 
>> Duerst, M., Ed., Yergeau, F., Ed., Ishida, R., Ed., Wolf, M., Ed. and T. Texin, Ed., "Character Model for the World Wide Web 1.0", W3C Recommendation, February 2005.  <http://www.w3.org/TR/charmod/>

Disagree. Listing a bunch of folks does not help the reference at all.

> To finish, why the intended status for this draft is BCP?  Longstanding IETF practice is to publish glossaries as Informational docs (previously, FYIs); examples are http://tools.ietf.org/html/rfc1208, http://tools.ietf.org/html/rfc1983, http://tools.ietf.org/html/rfc4949 and the predecessor of this draft itself - http://tools.ietf.org/html/rfc3536.  I think Informational would suit better here.

As you are well aware, there is differing opinion on this. We'll let the higher-ups decide.

--Paul Hoffman

---

From: John C Klensin <[email-masked]>
Date: Mon, 09 May 2011 12:11:12 -0400

--On Monday, May 09, 2011 08:23 -0700 Paul Hoffman
<[email-masked]> wrote:

>...
>> Proposal for inclusion of definition in Section 8.  I think
>> we could also define "noncharacter" here (and appropriate
>> entry in the Index).  My proposed definition:
>> 
>>>      noncharacter
>>>        
>>>         A noncharacter is a code point that is permanently
>>>         reserved in some particular coded character set and
>>>         is generally  forbidden to be used in open data
>>>         interchange. <UNICODE>
> 

The term is also fairly Unicode-specific.  While I agree with
Paul's answer, two additional observations:

(1) This document is about internationalization terminology, not
about characters, character sets, and terminology about them.
It is impossible to have a discussion about i18n (at least in
written text) without dealing with a lot of character set
issues, but that does not imply that all character set issues
and terminology should be included.

(2) With a possible exception when some definitional universe
falls cleanly into "A and not-A", one is always better off
defining things as what they are (or what the category
includes), rather than what they aren't.  While I understand
what the Unicode folks were trying to do and why, and am
relieved that no one asked me about a better term,
"noncharacter" isn't a strict opposite of "character".  Indeed,
if one adopts some common definitions of the "character"
category, "noncharacter" becomes a subset with a particular set
of properties.  In that context, the definition above isn't
really a definition but a description because "generally
forbidden" is insufficient to define what is in the category and
what isn't.  That is not a problem for Unicode because also all
of their terminology is descriptive: category-assignment is not
a consequence of definitions but of tables. If we were to define
it, we would have to include disclaimers about using the term.
I don't see that as worthwhile unless the term were used
prominently in i18n contexts in the IETF and, as Paul suggests,
it isn't.

>> To finish, why the intended status for this draft is BCP?
>> Longstanding IETF practice is to publish glossaries as
>> Informational docs (previously, FYIs); examples are
>> http://tools.ietf.org/html/rfc1208,
>> http://tools.ietf.org/html/rfc1983,
>> http://tools.ietf.org/html/rfc4949 and the predecessor of
>> this draft itself - http://tools.ietf.org/html/rfc3536.  I
>> think Informational would suit better here.
 
> As you are well aware, there is differing opinion on this.

Actually, "longstanding IETF practice" is to publish materials
that are normatively required for standards-track documents as
BCPs or on the standards-track, both because that makes sense
and because it avoids "normative reference" problems (I note
that draft-housley-two-maturity-levels makes no provision for
downward references to Informational documents, leaving RFC 3967
unchanged as the only way to deal with such references).  The
most-widely-cited example of this is BCP 2119.  

One way to look at the distinction is that some documents (RFCs
1208, 1392, and 4949 included) are glossaries that are
essentially descriptive of common contemporary practice.  So,
arguably, was 3536 itself.  Other documents are efforts to
normatively establish terminology and conventions for use
(especially) in standards-track documents.  While a good
document of that sort is always going to be written to avoid
confusion with popular terminology that is then in use, and to
identify that confusion when necessary), it is intended to
establish a usage model, not just describe one.  This document
joins 2119, 5137, and the "terminology" sections of many, many,
standards-track documents in that category. 

> We'll let the higher-ups decide.

Yes.   But, IMO, this makes sense to publish as Informational
iff there is a simultaneous RFC 3967 action to make it ok to
reference it normatively from standards-track documents.  That
would seem to me to be a poor use of resources, especially given
the precedents discussed above, but others may disagree.

regards,
     john

---

From: Andrew Sullivan <[email-masked]>
Date: Mon, 9 May 2011 18:04:04 -0400

On Mon, May 09, 2011 at 08:06:16AM +0300, Mykyta Yevstifeyev wrote:
> I think this definition is not correct.  "A way that humans
> interact" is too generalized.  I suppose the following definition
> would suit better here.
> 
> >    language
> >

Please, no.  Apart from the other remarks that Paul and John made,
this imports a controversial position about how language works.  It is
not at all clear that language is either a set of conventions or a set
of rules, unless you define "conventions" or "rules" broadly enough so
that computer geeks' heads would explode.

If one is too uncomfortable with "interact", I could contemplate an argument
for "communicate" instead.  

A

-- 
Andrew Sullivan
[email-masked]
Shinkuro, Inc.

---

From: Mykyta Yevstifeyev <[email-masked]>
Date: Tue, 10 May 2011 17:20:12 +0300

>> This sounds a bit confusing, since the previous sentence says "outside the IETF" and the next one mentions IETF RFCs.
Ok.
>>>         writing.<NONE>
Agreed; but the current isn't appropriate as well.  Considering a 
language being the humans interaction way is correct in its concept, but 
I think we should think about more exact definition.
>> Also "character" definition.  It would be useful to mention that "character" is often abbreviated to "char"
Thanks for this as well.
> A particular character can be considered both punctuation and a symbol.
OK; please clarify this in these definitions.

> This seems like overkill. We don't define the semantics of any other code points; why do it for control characters?
I proposed to add at least some phrase on the role of control 
characters.  ISO/IEC 6429 suits for this purpose fine, I think.
>>>          forbidden to be used in open data interchange.<UNICODE>
However Unicode is quite contiguous with the i18n topic; speaking about 
it we mostly speak about Unicode, this term is related to.
>> This version - 5.2.0 - is obsolete.  It is superseded by 6.0.0; the reference should be: "The Unicode Consortium. The Unicode Standard, Version 6.0.0, (Mountain View, CA: The Unicode Consortium, 2011. ISBN 978-1-936213-01-6)<http://www.unicode.org/versions/Unicode6.0.0/>"
> Noted.
>
Thanks for this.
>> I don't think they've invented time machine to write this in 20066 :-)  Obviously, this is a typo: s/20066/2006
The same.
>>> Duerst, M., Ed., Yergeau, F., Ed., Ishida, R., Ed., Wolf, M., Ed. and T. Texin, Ed., "Character Model for the World Wide Web 1.0", W3C Recommendation, February 2005.<http://www.w3.org/TR/charmod/>
You could then mention "Duerst, M., et al, ...".  See, we're not 
mentioning IETF as an author of RFCs; the same is with W3C.
>> To finish, why the intended status for this draft is BCP?  Longstanding IETF practice is to publish glossaries as Informational docs (previously, FYIs); examples arehttp://tools.ietf.org/html/rfc1208,http://tools.ietf.org/html/rfc1983,http://tools.ietf.org/html/rfc4949  and the predecessor of this draft itself -http://tools.ietf.org/html/rfc3536.  I think Informational would suit better here.
So let's leave this for IESG to decide.

Mykyta Yevstifeyev

---

From: Barry Leiba <[email-masked]>
Date: Tue, 10 May 2011 16:09:43 -0400

...
> Agreed; but the current isn't appropriate as well.  Considering a language
> being the humans interaction way is correct in its concept, but I think we
> should think about more exact definition.

I don't.  I think the text is fine as it is, and we should stop
pushing on this point and leave it alone.  [The only change I can see
supporting is inserting "verbal" before "way".  But there are
non-verbal languages, as well.]

>>> with.  The most common control characters semantics are specified in ISO/IEC
>>> 6429:1992 [ISO6429]" and adding the appropriate reference to ISO 6429, like
>>> this: "ISO/IEC, "ISO/IEC 6429:1992. Information technology -- Control
>>> functions for coded character sets",1992."
>>
>> This seems like overkill. We don't define the semantics of any other code
>> points; why do it for control characters?
>
> I proposed to add at least some phrase on the role of control characters.
>  ISO/IEC 6429 suits for this purpose fine, I think.

I'm ambivalent here.  On the one hand, I think the text is sufficient
as it is, and that we should move on.  On the other hand, with a whole
generation brought up with SmartPhones, I think fewer people
understand what control characters were -- WHY this set of codepoints
is special.  A bit of history wouldn't be a bad thing, if not strictly
necessary.

In any case, I don't support using ISO 6429 for it.  A few words of
background here would be enough, IF we want to put them in.  Pointing
to an 80-page, 150-euro document doesn't cut it for me.

>>>> Duerst, M., Ed., Yergeau, F., Ed., Ishida, R., Ed., Wolf, M., Ed. and T.
>>>> Texin, Ed., "Character Model for the World Wide Web 1.0", W3C
>>>> Recommendation, February 2005.<http://www.w3.org/TR/charmod/>
>>
> You could then mention "Duerst, M., et al, ...".  See, we're not mentioning
> IETF as an author of RFCs; the same is with W3C.

Paul's been consistent in using the organization as the author for all
non-IETF documents -- there's another W3C citation, many from Unicode,
a couple from ISO (ugh), and so on.  That seems the right thing to do
here, too.  He does have a note in asking the RFC Editor to normalize
the citations, and I think we should leave this issue to the RFC
Editor and their style guide.

Barry, as participant

---

From: Mykyta Yevstifeyev <[email-masked]>
Date: Wed, 11 May 2011 13:58:57 +0300

> non-verbal languages, as well.]
Adding "verbal" seems fine to me; this will clarify the definition a bit.
> to an 80-page, 150-euro document doesn't cut it for me.
How about the following text:

    control character

       The control character (also known as control code) is a special-purpose
       codepoint in a particular coded character set that generally does not
       represent any written symbol.  Generally, control characters are used
       to control handling  of data; they can be considered to be and  in-band
       signaling in the context of character encoding.<NONE>

       Currently, there are 65 control characters, occupying the ranges
       U+0000..U+001F and U+007F..U+009F.  The basic space character, U+0020,
       is often considered as a control character as well, making the total
       number 66.  In terminology adopted by Unicode from ASCII and the
       ISO 8859 standards, these codes are treated as belonging to three
       ranges: "C0" (for U+0000..U+001F), "C1" (for U+0080...U+009F), and
       the single control character "DEL" (U+007F).

> Editor and their style guide.
OK, let's leave this for RFC Editor.

Mykyta Yevstifeyev

---

From: Paul Hoffman <[email-masked]>
Date: Wed, 11 May 2011 07:07:05 -0700

> Adding "verbal" seems fine to me; this will clarify the definition a bit.

As Barry said, there are non-verbal languages as well. As co-author of this document, I would be very hesitant to disqualify the languages used by tens (maybe hundreds) of millions of people with this change unless the WG has a good reason to do so.

>       to control handling
>  of data; they can be considered to be and i
> n-band
>       signaling in the context of character encoding.  <NONE>
>    

You are again ignoring what others have said. What does this proposed text have to do with internationalization?

--Paul Hoffman

---

From: Andrew Sullivan <[email-masked]>
Date: Wed, 11 May 2011 10:25:17 -0400

> Adding "verbal" seems fine to me; this will clarify the definition a bit.

I am strongly opposed to the qualification "verbal".  It's flat out wrong.

A

-- 
Andrew Sullivan
[email-masked]
Shinkuro, Inc.

---

From: Mykyta Yevstifeyev <[email-masked]>
Date: Wed, 11 May 2011 18:00:56 +0300

> You are again ignoring what others have said. What does this proposed text have to do with internationalization?
Then should we consider the existing text to be unfamiliar to i18n?  It 
is just what we currently have with addition of some background info.

If you want to keep this document strictly on the internalization topic, 
you should consider many definitions of terms such as "formatting 
character", "compatibility character", "case" etc. inappropriate to it; 
but RFC 3536 itself and your draft actually define these terms.

---

From: Barry Leiba <[email-masked]>
Date: Wed, 11 May 2011 12:07:22 -0400

> As Barry said, there are non-verbal languages as well. As co-author of this
> document, I would be very hesitant to disqualify the languages used by tens
> (maybe hundreds) of millions of people with this change unless the WG has
> a good reason to do so.

This, plus Andrew's opposition, and the fact that there's been no
other call for changing the definition of "Language" here, leads me to
make the chair declaration that this is decided: the text remains as
it stands.

Barry, as chair

---

From: Joseph Yee <[email-masked]>
Date: Wed, 11 May 2011 12:08:26 -0400

> I am strongly opposed to the qualification "verbal".  It's flat out wrong.

+1, Strong oppose to "verbal", and support to replace "interact" to "communicate"

The definition of language is to make a generic term for all kinds of communication and then narrow down to writing related terminologies (script, writing system, character, etc).

Joseph

> 
> -- 
> Andrew Sullivan
> [email-masked]
> Shinkuro, Inc.
> _______________________________________________
> apps-discuss mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/apps-discuss

---

From: Dave CROCKER <[email-masked]>
Date: Wed, 11 May 2011 10:24:29 -0700

> The definition of language is to make a generic term for all kinds of
> communication and then narrow down to writing related terminologies (script,
> writing system, character, etc).

Correct.

Throughout this thread, people seem to be confusing "verbal" with "oral".  The
latter refers to speech.  Formally, the former is about verbs; that is, words.
So, for example, sign languages are verbal.

That said, the confusion is common enough to represent an emerging change in the
language to produce an equivalence of the words.

(See 3rd definition:  http://dictionary.reference.com/browse/verbal)

-- 

   Dave Crocker
   Brandenburg InternetWorking
   bbiw.net

---

From: Barry Leiba <[email-masked]>
Date: Wed, 11 May 2011 14:01:48 -0400

> Throughout this thread, people seem to be confusing "verbal" with "oral".

When I suggested "verbal", I specifically meant "in words", not
"oral".  But there's objection to making that change, and I don't
think there's value in messing with the definition in the doc at that
level.

Barry